unit ClientModuleUnit1;

interface

uses
  System.SysUtils, System.Classes, ClientClassesUnit1, Data.DBXDataSnap,
  IndyPeerImpl, Data.DBXCommon, Data.DB, Data.SqlExpr, Datasnap.DBClient,
  Datasnap.DSConnect;

type
  TClientModule1 = class(TDataModule)
    SQLConnection1: TSQLConnection;
    DSProviderConnection1: TDSProviderConnection;
    ClientDataSet1: TClientDataSet;
    ClientDataSet1SKU: TWideStringField;
    ClientDataSet1Product: TWideStringField;
    ClientDataSet1Edition: TWideStringField;
    ClientDataSet1License: TWideStringField;
    ClientDataSet1Users: TWideStringField;
    ClientDataSet1Price: TFloatField;
    DataSource1: TDataSource;
    procedure DataModuleCreate(Sender: TObject);
  private
    FInstanceOwner: Boolean;
    FServerMethods1Client: TServerMethods1Client;
    function GetServerMethods1Client: TServerMethods1Client;
    { Private declarations }
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property InstanceOwner: Boolean read FInstanceOwner write FInstanceOwner;
    property ServerMethods1Client: TServerMethods1Client read GetServerMethods1Client write FServerMethods1Client;

end;

var
  ClientModule1: TClientModule1;

implementation
uses
  FMX.Dialogs;

{%CLASSGROUP 'FMX.Types.TControl'}

{$R *.dfm}

{%CLASSGROUP 'System.Classes.TPersistent'}

constructor TClientModule1.Create(AOwner: TComponent);
begin
  inherited;
  FInstanceOwner := True;
end;

procedure TClientModule1.DataModuleCreate(Sender: TObject);
var
  user: String;
begin
  user := InputBox('User', 'username: ', 'user');
  SQLConnection1.Params.Values['DSAuthenticationUser'] := user;
  SQLConnection1.Params.Values['DSAuthenticationPassword'] := user;
end;

destructor TClientModule1.Destroy;
begin
  FServerMethods1Client.Free;
  inherited;
end;

function TClientModule1.GetServerMethods1Client: TServerMethods1Client;
begin
  if FServerMethods1Client = nil then
  begin
    SQLConnection1.Open;
    FServerMethods1Client:= TServerMethods1Client.Create(SQLConnection1.DBXConnection, FInstanceOwner);
  end;
  Result := FServerMethods1Client;
end;

end.
